Package org.opentcs.data.order

# Class Route.Step

java.lang.Object
org.opentcs.data.order.Route.Step

All Implemented Interfaces:
  `java.io.Serializable`

Enclosing class:
  Route

    public static class Route.Step
    extends java.lang.Object
    implements java.io.Serializable

A single step in a route.

See Also:
  Serialized Form

- ## Constructor Summary

  Constructors
  Constructor | Description
  --- | ---
  `Step​(Path path, Point srcPoint, Point destPoint, Vehicle.Orientation orientation, int routeIndex)` | Creates a new instance.
  `Step​(Path path, Point srcPoint, Point destPoint, Vehicle.Orientation orientation, int routeIndex, boolean executionAllowed)` | Creates a new instance.

- ## Method Summary

  Modifier and Type | Method | Description
  --- | --- | ---
  `boolean` | `equals​(java.lang.Object o)` |
  `Point` | `getDestinationPoint()` | Returns the point that is reached by travelling the path.
  `Path` | `getPath()` | Returns the path to travel.
  `int` | `getRouteIndex()` | Returns this step's index in the vehicle's route.
  `Point` | `getSourcePoint()` | Returns the point that the vehicle is starting from.
  `Vehicle.Orientation` | `getVehicleOrientation()` | Returns the direction into which the vehicle is supposed to travel.
  `int` | `hashCode()` |
  `boolean` | `isExecutionAllowed()` | Returns whether execution of this step is allowed.
  `java.lang.String` | `toString()` |

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### Step

    public Step​(@Nullable Path path, @Nullable Point srcPoint, @Nonnull Point destPoint, @Nonnull Vehicle.Orientation orientation, int routeIndex, boolean executionAllowed)
    Creates a new instance.
    Parameters:
      `path` - The path to travel.
      `srcPoint` - The point that the vehicle is starting from.
      `destPoint` - The point that is reached by travelling the path.
      `orientation` - The vehicle's orientation on this step.
      `routeIndex` - This step's index in the vehicle's route.
      `executionAllowed` - Whether execution of this step is allowed.

  - ### Step

    public Step​(@Nullable Path path, @Nullable Point srcPoint, @Nonnull Point destPoint, @Nonnull Vehicle.Orientation orientation, int routeIndex)
    Creates a new instance.
    Parameters:
      `path` - The path to travel.
      `srcPoint` - The point that the vehicle is starting from.
      `destPoint` - The point that is reached by travelling the path.
      `orientation` - The vehicle's orientation on this step.
      `routeIndex` - This step's index in the vehicle's route.

- ## Method Details

  - ### getPath

    @Nullable public Path getPath()
    Returns the path to travel.
    Returns:
      The path to travel. May be `null` if the vehicle does not really have to move.

  - ### getSourcePoint

    @Nullable public Point getSourcePoint()
    Returns the point that the vehicle is starting from.
    Returns:
      The point that the vehicle is starting from. May be `null` if the vehicle does not really have to move.

  - ### getDestinationPoint

    @Nonnull public Point getDestinationPoint()
    Returns the point that is reached by travelling the path.
    Returns:
      The point that is reached by travelling the path.

  - ### getVehicleOrientation

    @Nonnull public Vehicle.Orientation getVehicleOrientation()
    Returns the direction into which the vehicle is supposed to travel.
    Returns:
      The direction into which the vehicle is supposed to travel.

  - ### getRouteIndex

    public int getRouteIndex()
    Returns this step's index in the vehicle's route.
    Returns:
      This step's index in the vehicle's route.

  - ### isExecutionAllowed

    public boolean isExecutionAllowed()
    Returns whether execution of this step is allowed.
    Returns:
      `true`, if execution of this step is allowed, otherwise `false`.

  - ### equals

    public boolean equals​(java.lang.Object o)
    Overrides:
      `equals` in class `java.lang.Object`

  - ### hashCode

    public int hashCode()
    Overrides:
      `hashCode` in class `java.lang.Object`

  - ### toString

    public java.lang.String toString()
    Overrides:
      `toString` in class `java.lang.Object`